﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
Sub Class_Globals
	#if B4A
	Private const tempImageFile As String = "tempimage.jpg"
	Private Provider As FileProvider
	Private ion As Object
	#Else If B4i
	Private Camera As Camera
	#end if
	Public CallingPage As String
	Public PhotoType = "" As String
	Private bmpSize = 2048 As Int
End Sub

'You can add more parameters here.
Public Sub Initialize( ParentPageID As String )
	#if B4A
	Provider.Initialize
	StartService(KeepRunningService)
	#Else If B4i
	Camera.Initialize("Camera", B4XPages.GetNativeParent(B4XPages.getpage(ParentPageID)))
	'Camera.Initialize("Camera", B4XPages.GetNativeParent(Me))
	#end if
End Sub

Public Sub GetPhoto
	TakePicture ( 1024, 2048 )
	Wait For Image_Available(Success As Boolean, bmp As B4XBitmap)
	If Success Then
		If bmp.Width > bmpSize Or bmp.Height > bmpSize Then
			If bmp.Width > bmp.Height Then
				Dim NewWidth As Int = Round( bmp.Width * ( bmpSize / bmp.Width ) )
				Dim NewHeight As Int = Round( bmp.Height * ( NewWidth / bmp.Width) )
			Else
				Dim NewHeight As Int = Round( bmp.Height * ( bmpSize / bmp.Height ) )
				Dim NewWidth As Int = Round( bmp.Width * ( NewHeight / bmp.Height) )
			End If
			Log("bmp.width is " & bmp.Width)
			Log("bmp.height is " & bmp.height)
			Log("NewWidth is " & NewWidth)
			Log("NewHeight is " & NewHeight)
			bmp = bmp.Resize( NewWidth, NewHeight, True)
		End If

		Dim OutputStream1 As OutputStream
		OutputStream1.InitializeToBytesArray(1000)
			#if B4i
				bmp.WriteToStream(OutputStream1, 75, "JPEG")
			#else
		bmp.WriteToStream(OutputStream1, 100, "JPEG")
			#End If

		'Dim Buffer() As Byte = OutputStream1.ToBytesArray

		Dim Out As OutputStream
		Out = File.OpenOutput(B4XPages.MainPage.FilesDir, "photo_other.jpg",False)
		bmp.WriteToStream(Out, 90, "JPEG")
		Out.Close

		If CallingPage = "AddPhoto" Then
			B4XPages.MainPage.AddPhoto.UpdatePhoto
		End If
			
	End If
End Sub

#if B4A
Private Sub TakePicture (TargetWidth As Int, TargetHeight As Int)
	Log("entering TakePicture")
	Dim i As Intent
	i.Initialize("android.media.action.IMAGE_CAPTURE", "")
	File.Delete(Provider.SharedFolder, tempImageFile)
	Dim u As Object = Provider.GetFileUri(tempImageFile)
	i.PutExtra("output", u) 'the image will be saved to this path
	Try
		Log("Calling StartActivityForResult")
		Wait For (CallSub(KeepRunningService, "Start")) Complete (Unused As Boolean)
		StartActivityForResult(i)
		Wait For ion_Event (MethodName As String, Args() As Object)
		Log("Waited for ion_Event")
		CallSub(KeepRunningService, "Stop")
		Dim bmp As B4XBitmap
		If -1 = Args(0) Then
			Try
				Dim in As Intent = Args(1)
				If File.Exists(Provider.SharedFolder, tempImageFile) Then
					Dim Exif As ExifData
					Exif.Initialize(Provider.SharedFolder, tempImageFile)
					bmp = LoadBitmapSample(Provider.SharedFolder, tempImageFile, Max(TargetWidth, TargetHeight), Max(TargetWidth, TargetHeight))
					Log("Orientation: " & Exif.getAttribute(Exif.TAG_ORIENTATION))
					Select Exif.getAttribute(Exif.TAG_ORIENTATION)
						Case Exif.ORIENTATION_ROTATE_180 '3
							bmp = bmp.Rotate(180)
						Case Exif.ORIENTATION_ROTATE_90 '6
							bmp = bmp.Rotate(90)
						Case Exif.ORIENTATION_ROTATE_270 '8
							bmp = bmp.Rotate(270)
					End Select
					bmp = bmp.Resize(TargetWidth, TargetHeight, True)
				Else If in.HasExtra("data") Then 'try to get thumbnail instead
					Dim jo As JavaObject = in
					bmp = jo.RunMethodJO("getExtras", Null).RunMethod("get", Array("data"))
				End If
			Catch
				Log(LastException)
			End Try
		End If
		Log("about to call image_available")
		CallSubDelayed3(Me, "Image_Available", bmp.IsInitialized, bmp)
	Catch
		ToastMessageShow("Camera is not available.", True)
		Log(LastException)
		CallSubDelayed3(Me, "Image_Available", False, Null)
	End Try
End Sub

Sub StartActivityForResult(i As Intent)
	Dim jo As JavaObject = Me
	jo = jo.RunMethod("getBA", Null)
	ion = jo.CreateEvent("anywheresoftware.b4a.IOnActivityResult", "ion", Null)
	jo.RunMethod("startActivityForResult", Array(ion, i))
	Log("Completed StartActivityForResult")
End Sub
#else if B4i
Private Sub TakePicture (TargetWidth As Int, TargetHeight As Int)
	Camera.TakePicture
	Dim TopPage As String = B4XPages.GetManager.GetTopPage.Id
	Wait For Camera_Complete (Success As Boolean, Image As Bitmap, VideoPath As String)
	B4XPages.GetManager.mStackOfPageIds.Add(TopPage) 'this is required as the page will be removed from the stack when the external camera page appears.
	If Success Then
		Dim bmp As B4XBitmap = Image
		bmp.Resize(TargetWidth, TargetHeight, True)
		CallSubDelayed3(Me, "Image_Available", True, bmp)
	Else
		CallSubDelayed3(Me, "Image_Available", False, Null)
	End If
End Sub
#end if